Index: trunk/sources/HeuristicLab/3.3/Tests/CloningConstructorTest.cs
===================================================================
--- trunk/sources/HeuristicLab/3.3/Tests/CloningConstructorTest.cs	(revision 5272)
+++ trunk/sources/HeuristicLab/3.3/Tests/CloningConstructorTest.cs	(revision 5306)
@@ -13,5 +13,5 @@
     [ClassInitialize]
     public static void MyClassInitialize(TestContext testContext) {
-      PluginLoader.pluginAssemblies.Any();
+      PluginLoader.Assemblies.Any();
     }
 
@@ -22,5 +22,5 @@
       foreach (Type deepCloneableType in ApplicationManager.Manager.GetTypes(typeof(IDeepCloneable))) {
         //test only types contained in HL plugin assemblies
-        if (!PluginLoader.pluginAssemblies.Contains(deepCloneableType.Assembly)) continue;
+        if (!PluginLoader.Assemblies.Contains(deepCloneableType.Assembly)) continue;
 
         bool found = false;
Index: trunk/sources/HeuristicLab/3.3/Tests/ContentViewTests.cs
===================================================================
--- trunk/sources/HeuristicLab/3.3/Tests/ContentViewTests.cs	(revision 5272)
+++ trunk/sources/HeuristicLab/3.3/Tests/ContentViewTests.cs	(revision 5306)
@@ -52,5 +52,5 @@
     [ClassInitialize]
     public static void MyClassInitialize(TestContext testContext) {
-      PluginLoader.pluginAssemblies.Any();
+      PluginLoader.Assemblies.Any();
     }
 
Index: trunk/sources/HeuristicLab/3.3/Tests/PluginDependenciesTest.cs
===================================================================
--- trunk/sources/HeuristicLab/3.3/Tests/PluginDependenciesTest.cs	(revision 5272)
+++ trunk/sources/HeuristicLab/3.3/Tests/PluginDependenciesTest.cs	(revision 5306)
@@ -38,5 +38,5 @@
     [ClassInitialize]
     public static void MyClassInitialize(TestContext testContext) {
-      loadedPlugins = PluginLoader.pluginAssemblies.ToDictionary(a => a, GetPluginFromAssembly);
+      loadedPlugins = PluginLoader.Assemblies.Where(x => PluginLoader.IsPluginAssembly(x)).ToDictionary(a => a, GetPluginFromAssembly);
       pluginNames = loadedPlugins.ToDictionary(a => a.Key.GetName().FullName, a => GetPluginName(a.Value));
 
Index: trunk/sources/HeuristicLab/3.3/Tests/PluginLoader.cs
===================================================================
--- trunk/sources/HeuristicLab/3.3/Tests/PluginLoader.cs	(revision 5272)
+++ trunk/sources/HeuristicLab/3.3/Tests/PluginLoader.cs	(revision 5306)
@@ -12,5 +12,5 @@
     public const string TestAccessorAssemblyExtension = "_Accessor.dll";
     public const string TestAssemblyExtension = ".Tests.dll";
-    public static List<Assembly> pluginAssemblies;
+    public static List<Assembly> Assemblies;
 
     static PluginLoader() {
@@ -19,8 +19,8 @@
         Assembly.LoadFrom(path);
 
-      pluginAssemblies = AppDomain.CurrentDomain.GetAssemblies().Where(IsPluginAssembly).ToList();
+      Assemblies = AppDomain.CurrentDomain.GetAssemblies().ToList();
     }
 
-    private static bool IsPluginAssembly(Assembly assembly) {
+    public static bool IsPluginAssembly(Assembly assembly) {
       return assembly.GetExportedTypes()
         .Where(t => typeof(IPlugin).IsAssignableFrom(t) && !t.IsAbstract && !t.IsInterface).Any();
Index: trunk/sources/HeuristicLab/3.3/Tests/StorableConstructorTest.cs
===================================================================
--- trunk/sources/HeuristicLab/3.3/Tests/StorableConstructorTest.cs	(revision 5272)
+++ trunk/sources/HeuristicLab/3.3/Tests/StorableConstructorTest.cs	(revision 5306)
@@ -16,5 +16,5 @@
     [ClassInitialize]
     public static void MyClassInitialize(TestContext testContext) {
-      PluginLoader.pluginAssemblies.Any();
+      PluginLoader.Assemblies.Any();
     }
 
@@ -26,5 +26,5 @@
         .Where(t => StorableClassAttribute.IsStorableClass(t))) {
         //test only types contained in HL plugin assemblies
-        if (!PluginLoader.pluginAssemblies.Contains(storableType.Assembly)) continue;
+        if (!PluginLoader.Assemblies.Contains(storableType.Assembly)) continue;
 
         IEnumerable<ConstructorInfo> ctors = storableType.GetConstructors(BindingFlags.Instance | BindingFlags.NonPublic | BindingFlags.Public);