Index: branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager/3.3/HiveJob.cs
===================================================================
--- branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager/3.3/HiveJob.cs	(revision 5294)
+++ branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager/3.3/HiveJob.cs	(revision 5309)
@@ -178,7 +178,7 @@
         } else if (Job.Optimizer is Optimization.BatchRun) {
           Optimization.BatchRun batchRun = Job.OptimizerAsBatchRun;
-          if (batchRun.Algorithm != null) {
+          if (batchRun.Optimizer != null) {
             while (this.childHiveJobs.Count < batchRun.Repetitions) {
-              this.childHiveJobs.Add(new HiveJob(batchRun.Algorithm));
+              this.childHiveJobs.Add(new HiveJob(batchRun.Optimizer));
             }
             while (this.childHiveJobs.Count > batchRun.Repetitions) {
@@ -201,5 +201,5 @@
           Optimization.BatchRun batchRun = Job.OptimizerAsBatchRun;
           batchRun.RepetitionsChanged += new EventHandler(batchRun_RepetitionsChanged);
-          batchRun.AlgorithmChanged += new EventHandler(batchRun_AlgorithmChanged);
+          batchRun.OptimizerChanged += new EventHandler(batchRun_OptimizerChanged);
         }
 
@@ -219,5 +219,5 @@
           Optimization.BatchRun batchRun = Job.OptimizerAsBatchRun;
           batchRun.RepetitionsChanged -= new EventHandler(batchRun_RepetitionsChanged);
-          batchRun.AlgorithmChanged -= new EventHandler(batchRun_AlgorithmChanged);
+          batchRun.OptimizerChanged -= new EventHandler(batchRun_OptimizerChanged);
         }
 
@@ -227,5 +227,5 @@
     }
 
-    void batchRun_AlgorithmChanged(object sender, EventArgs e) {
+    void batchRun_OptimizerChanged(object sender, EventArgs e) {
       if (syncJobsWithOptimizers) {
         this.childHiveJobs.Clear();
@@ -311,5 +311,5 @@
     ///   replace the child-optimizer in the experiment
     /// if this.Optimizer is BatchRun
-    ///   add the runs from the optimizerJob to the batchrun and replace the algorithm
+    ///   add the runs from the optimizerJob to the batchrun and replace the Optimizer
     /// </summary>
     public void UpdateChildOptimizer(OptimizerJob optimizerJob, Guid childJobId) {
@@ -344,10 +344,10 @@
 
     /// <summary>
-    /// Adds the runs from the optimizerJob to the batchrun and replaces the algorithm 
+    /// Adds the runs from the optimizerJob to the batchrun and replaces the Optimizer 
     /// Sideeffect: the optimizerJob.Optimizer will be prepared (scopes are deleted and executionstate will be reset)
     /// </summary>
     private void UpdateOptimizerInBatchRun(BatchRun batchRun, OptimizerJob optimizerJob) {
-      if (batchRun.Algorithm == null) {
-        batchRun.Algorithm = (IAlgorithm)optimizerJob.Optimizer; // only set the first optimizer as algorithm. if every time the Algorithm would be set, the runs would be cleared each time
+      if (batchRun.Optimizer == null) {
+        batchRun.Optimizer = optimizerJob.Optimizer; // only set the first optimizer as algorithm. if every time the Algorithm would be set, the runs would be cleared each time
       }
       foreach (IRun run in optimizerJob.Optimizer.Runs) {
@@ -441,5 +441,5 @@
       } else if (withoutChildOptimizers && this.Job.Optimizer is Optimization.BatchRun) {
         OptimizerJob clonedJob = (OptimizerJob)this.Job.Clone();
-        clonedJob.OptimizerAsBatchRun.Algorithm = null;
+        clonedJob.OptimizerAsBatchRun.Optimizer = null;
         jobByteArray = SerializedJob.Serialize(clonedJob);
       } else if (this.Job.Optimizer is IAlgorithm) {
Index: branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager/3.3/Jobs/OptimizerJob.cs
===================================================================
--- branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager/3.3/Jobs/OptimizerJob.cs	(revision 5294)
+++ branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager/3.3/Jobs/OptimizerJob.cs	(revision 5309)
@@ -147,5 +147,5 @@
     public virtual void Start() {
       if ((optimizer is Optimization.Experiment && OptimizerAsExperiment.Optimizers.Count == 0) || // experiment would not fire OnStopped if it has 0 optimizers
-          (optimizer is Optimization.BatchRun && OptimizerAsBatchRun.Algorithm == null)) { // batchrun would not fire OnStopped if algorithm == null
+          (optimizer is Optimization.BatchRun && OptimizerAsBatchRun.Optimizer == null)) { // batchrun would not fire OnStopped if algorithm == null
         OnJobStopped();
       } else {